#!/usr/bin/tcl

#example Tcl-IOC startup script
#This file should show the features.
#It is not a template for normal startup scrips

#init EPICS ioccore
set app myTclIocApp
load O.linux-x86/lib${app}.so tclioc
dbLoadDatabase O.Common/${app}.dbd
${app}_registerRecordDeviceDriver

#create records using TCL programming
set scan "1 second"
for {set n 1} {$n <= 20} {incr n} {
    dbLoadRecords example.template "number=$n,scan=$scan"
}

iocInit

#some EPICS commands with output redirection
dbl > recordlist.log

#redirection to an open Tcl file
set file [open iocinfo.log w]
puts $file "list of all records:"
dbl "" RTYP >@ $file
close $file

#redirection to command pipe
puts "\nredirection to pipe:"
puts "record               | RTYP     "
puts "=====================|=========="
set pipe [open {|awk {-F(,|\")} {{printf ("%-20s | %s\n", $1, $3)}}} w]
dbl "" RTYP >@ $pipe
close $pipe

#redirection to variable
puts "\nredirection to variable:"
dbnr >$ recordtypes
puts "\$recordtypes =\n$recordtypes"

#redirection to result
puts "\nredirection to command result:"
puts "\[thread >$$\] ="
puts [thread >$$]

#go interactive
commandloop -prompt1 {puts -nonewline "epics> "}
